

/****** Object : Table [dbo].[AgentGuardAssetTemp] Copyright TECK SYSTEM SOFT 2018 TB Source ******/


UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] SET [Dashboard] = '' WHERE [Dashboard] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] SET [Insert_Date] = '' WHERE [Insert_Date] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] SET [Customer] = '' WHERE [Customer] IS NULL  /* Source */
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] SET [Site] = '' WHERE [Site] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] SET [MachineName] = '' WHERE [MachineName] IS NULL
UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] SET [Presence] = '' WHERE [Presence] IS NULL

 INSERT INTO [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAsset]  /* Target */
([Insert_Date]    
	  ,[Customer]
      ,[Site]  
	  ,[Dashboard] 
      ,[Presence]
      ,[MachineName]     
)

SELECT  
[Insert_Date]
      ,[Customer]
      ,[Site]
      ,[Dashboard]
      ,[Presence]
      ,[MachineName]     
     
FROM
(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' + [Customer] + '-' + [Site] + '-' + [Dashboard] + '-' + [Presence] + '-' + [MachineName] AS SEARCH_STRING
	  ,[Insert_Date]  /* Add for test purpose only */
      ,[Customer]
      ,[Site]
      ,[Dashboard]   
      ,[Presence]
      ,[MachineName]
      ,[Asset_ID]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] /* Source */
WHERE CONVERT(nvarchar(25),[Insert_Date]) + '-' +   [Customer] + '-' + [Site] + '-' + [Dashboard] + '-' + [Presence] + '-' + [MachineName]  NOT IN 

(SELECT DISTINCT CONVERT(nvarchar(25),[Insert_Date]) + '-' +  [Customer] + '-' + [Site] + '-' + [Dashboard] + '-' + [Presence] + '-' + [MachineName] AS SEARCH_STRING
FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAsset]) ) TBL  /* Target */

/****** Object : UPDATE existing entries with the lastest values ******/

UPDATE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAsset] /* Target */
SET  
/* [Insert_Date] = REQUEST.[Insert_Date], */
[Customer] = REQUEST.[Customer],
[Site] = REQUEST.[Site],
[Dashboard] = REQUEST.[Dashboard],
[Presence] = REQUEST.[Presence],
[MachineName] = REQUEST.[MachineName]

      -- Last UPDATE time

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAsset]  AGUARD, /* Target */

/****** Object : Select values ******/

(SELECT TEMP_JOIN.[Asset_ID],
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Dashboard],
TEMP_JOIN.[Presence],
TEMP_JOIN.[MachineName]

FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] TEMP /* Source */
INNER JOIN  [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp] TEMP_JOIN  /* Source */
ON TEMP_JOIN.[Customer] = TEMP.[Customer]
WHERE 
TEMP.[Insert_Date] = TEMP_JOIN .[Insert_Date] AND
TEMP.[Site] = TEMP_JOIN .[Site] AND
TEMP.[Dashboard] = TEMP_JOIN .[Dashboard] AND
TEMP.[Presence] = TEMP_JOIN .[Presence] AND
TEMP.[MachineName] =  TEMP_JOIN .[MachineName]

GROUP BY
TEMP_JOIN.[Insert_Date],
TEMP_JOIN.[Customer],
TEMP_JOIN.[Site],
TEMP_JOIN.[Dashboard],
TEMP_JOIN.[Presence],
TEMP_JOIN.[MachineName],
TEMP_JOIN.[Asset_ID]

HAVING max(TEMP.Asset_ID) = TEMP_JOIN.[Asset_ID]) AS REQUEST
WHERE
    AGUARD.[Customer] = REQUEST.[Customer]
AND AGUARD.[Site] = REQUEST.[Site]
AND AGUARD.[Dashboard] = REQUEST.[Dashboard]
AND AGUARD.[Presence] = REQUEST.[Presence]
AND AGUARD.[MachineName] = REQUEST.[MachineName] 

/****** Object : Clean Double witrh same date hour time SQL Table ******/

;WITH CTE AS (
  SELECT 
    [Dashboard],
    [Insert_Date],
    [MachineName],
    [Presence],
    [Customer],
    [Site],
    ROW_NUMBER() OVER (PARTITION BY 
                        [MachineName],
                        [Dashboard],
                        [Presence],
                        [Customer],
                        [Site],
                        DATEPART(YEAR, [Insert_Date]),
                        DATEPART(MONTH, [Insert_Date]),
                        DATEPART(DAY, [Insert_Date]),
                        DATEPART(HOUR, [Insert_Date]),
                        (DATEPART(MINUTE, [Insert_Date]) / 5) * 5 
                      ORDER BY [Insert_Date]) AS RN
  FROM [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAsset]
)
DELETE FROM CTE WHERE RN > 1;

/****** Object : Clean Temporary SQL Table ******/

 TRUNCATE TABLE [Monitorpack_GuardReportsMonitorpack].[dbo].[AgentGuardAssetTemp]
